﻿Type=Service
Version=3.8
B4A=true
@EndOfDesignText@
#Region Service Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals

	Dim Parser As SaxParser
	Dim shouldScheduleNextTask As Boolean
	shouldScheduleNextTask = True 'by default we are scheduling the next update
    
	'private variables
	Dim ListOfMaps As List
	Dim dbmap As Map
    Dim FeedUrl As String
End Sub
Sub Service_Create
   
	ListOfMaps.Initialize
	Parser.Initialize
' Make sure the database stays active while running
   If DbConnect.dbSQL.IsInitialized = False Then
        DbConnect.InitdbSQL
    End If

End Sub

Sub Service_Start(StartingIntent As Intent)

    If shouldScheduleNextTask = True Then
	   'Check for Feeds every 5 minutes
	   'It is a kind gesture to contact the website you are pulling feeds from and ask them how often you can check for updates
		StartServiceAt("", DateTime.Now + 5 * DateTime.TicksPerMinute,True)
	End If

    'should you have to post a soap string create it here then change the poststring
	'dim mysoapxml as string
	'getfeed.postString(FeedUrl,mysoapxml)
	

   ToastMessageShow("Loading Feed " & FeedUrl, True)
   Dim getFeed As HttpJob
   getFeed.Initialize("getFeed", Me)
   'sending a null soapxml
   'here we are just downloading the datatable as there is not soap post
   getFeed.Download(FeedUrl)
   'getFeed.PostString(FeedUrl,"")
   'getFeed.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
   'getFeed.GetRequest.Timeout = 20000

End Sub

Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
    'Log(Name)
	
	If Name = "dtResult" Then
	dbmap.Initialize
	End If
End Sub
Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
' Keep Comment Selection of Elements to Parse and DataType
'<dtResult diffgr:id="dtResult9" msdata:rowOrder="8">
'<ID_EventoLugar>9</ID_EventoLugar>
'<ID_Evento>1</ID_Evento>
'<LugarLetra>A</LugarLetra>
'<LugarNum>9</LugarNum>
'<PosX>410</PosX>
'<PosY>694</PosY>
'</dtResult>
'Create DataTable Structure
'dbmap.Put("author" this is the name of your dataTable Column Name
'Now I want to define my table Structure notice that all the column names are lowercase
'SQL1.ExecNonQuery("CREATE TABLE feeditems(id INTEGER PRIMARY KEY ASC, title TEXT, pubdate TEXT, link TEXT, guid TEXT, author TEXT, creator TEXT, description TEXT, comments integer)")
	
  'Every Segment Case should match the case of the incoming xml structure, it should also match the reading sequence order of the parent element
'Since the object here is to insert into sqlite table with have to replace all single quotes
If Parser.Parents.IndexOf("dtResult") > -1 Then
  'Make sure we read the segments as lowercase
  'if your table is not filled correctly uncomment the following line and log all the segment names
  Log(Name)
	Select Name.ToLowerCase
	
		Case "id_eventolugar"
			 dbmap.Put("id_eventolugar", Text.ToString.Replace("'","''"))
		Case "id_evento"
			dbmap.Put("id_evento", Text.ToString.Replace("'","''"))
		Case "lugarletra"
			dbmap.Put("lugarletra", Text.ToString.Replace("'","''"))
		Case "lugarnum"
			dbmap.Put("lugarnum", Text.ToString.Replace("'","''"))
		Case "posx" 
			  dbmap.Put("posx",Text.ToString.Replace("'","''"))
		Case "posy"
			dbmap.Put("posy",Text.ToString.Replace("'","''"))	  
	End Select
	End If
	If Name = "dtResult" Then
		ListOfMaps.Add(dbmap)
	End If
	
	
End Sub
Sub JobDone (Job As HttpJob)
Dim In As InputStream
  
  Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
 
   
   If Job.Success = True Then
  
     ' Log(Job.GetString)
	 In = Job.GetInputStream
'     Dim tr As TextReader
'    tr.Initialize2(In, "ISO-8859-1")
'    Parser.Parse2(tr, "Parser")
'    In.Close
'		'parse the new results
		Parser.Parse(In, "Parser")
		In.Close
		
		If ListOfMaps.Size > 0 Then
		        'Because I only want to get the newest results i delete the old records from the table before i insert them
				'the deleteRecords function was added to the dbutils class (not in original code)
			    dbutils.DeleteRecords(DbConnect.dbsql,"dtResult")
				dbutils.InsertMaps(DbConnect.dbsql, "dtResult",ListOfMaps)
				    'update the main web view
					CallSub(Main, "UpdateWebView")
		       
				 
	       ListOfMaps.Clear
		End If
		

   Else
       Log("Error: " & Job.ErrorMessage)

   End If
   Job.Release
   
End Sub


Sub Service_Destroy

End Sub
